#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h> // if 'sleep()' used.

static unsigned long long thread_nr = 0LL;

pthread_mutex_t mutex_;

void* inc_thread_nr(void* arg) {
    (void*)arg;
    pthread_mutex_lock(&mutex_);
    thread_nr ++;
    printf("thread_nr = %lld\n", thread_nr);
    pthread_mutex_unlock(&mutex_);
    return NULL;
}

#define THREADS 2
int main(int argc, char *argv[])
{
    pthread_t pid[THREADS+1];
    int cnt;

    pthread_mutex_init(&mutex_, NULL);

    cnt = 0;
    while (cnt < THREADS) {
        if (pthread_create(&pid[cnt], NULL, (void*)inc_thread_nr, NULL)) break;
        cnt += 1;
    }
    while (cnt --> 0) pthread_join(pid[cnt], NULL); // wait for all processes to terminate

    pthread_mutex_destroy(&mutex_);

    printf("Tested %lld threads OK\n", thread_nr);
    exit(0);
    return(0);
}
